import serial,time
from twisted.internet.protocol import Protocol, Factory
from twisted.internet import reactor

### Protocol Implementation

# This is just about the simplest possible protocol
class BigBoard(Protocol):
    def __init__(self):
        #Protocol.__init__(self)
        lines = []

    def dataReceived(self, data):
        """As soon as any data is received, write it back."""
        print data
        print self.lines
        self.lines.append(data)
        if len(self.lines) == 20:
            self.transport.loseConnection()

    def slowWrite(self,c):
        self.ser.write('X')
        time.sleep(0.05)

    def updateBitmap(self):
        self.ser = serial.Serial('/dev/cu.usbserial0',9600,timeout=None,xonxoff=0,rtscts=0)
        self.ser.open()
        self.slowWrite('X')
        self.slowWrite(chr(20))
        for i in range(0,20):
            b = 0
            for j in range(0,8):
                b |=  int(l[i][j]) << j
            self.slowWrite(chr(b))

        while self.ser.inWaiting():
            print self.ser.read();

        self.ser.close()

def main():
    f = Factory()
    f.protocol = BigBoard()
    reactor.listenTCP(8000, f)
    reactor.run()

if __name__ == '__main__':
    main()


f = open('f1','r')
l = f.readlines()
f.close()


